from bs4 import BeautifulSoup
import pandas as pd
from datetime import datetime
from selenium import webdriver
import openpyxl
import re
from operator import itemgetter
import time

driver = webdriver.Chrome()
driver.minimize_window()

url = 'https://www.sbostats.com/partite'

tgame = []

driver.get(url)

tab = driver.find_element_by_xpath("/html/body/div[2]/div[3]/div/div/div[2]/app-root/div/app-matches/section")
tab1 = tab.find_elements_by_tag_name('a')

for elem0 in tab1:
    game = []
    lk = elem0.get_attribute('href')
    naz = lk.split()

    rq1 = lk.split("&quote=")
    rq2 = rq1[1].split("&direction=")
    val = rq2[0]
    seg0 = rq2[1].split("&id=")
    seg = seg0[0]
    if seg == "away":
        segr = "2"
    if seg == "home":
        segr = "1"
    rval = 1.90

    if float(val) > rval:
        game.append(lk)
        game.append(val)
        game.append(segr)
        tgame.append(game)

bktest_tot = []

for inc in tgame:
    bktest = []
    lk = inc[0]
    val = inc[1]
    segr = inc[2]

    driver.get(lk)

    stat0 = driver.find_elements_by_class_name("widget__title.card__header.card__header2.card__header--has-btn")

    if len(stat0) != 0:

        squadre = driver.find_element_by_xpath("/html[1]/body[1]/div[2]/div[3]/div[1]/div[1]/div[1]/h4[1]/span[1]")
        campnaz = driver.find_element_by_css_selector(
            "html body div.site-wrapper.clearfix div.page-heading div div div ol")

        stat = stat0[0].find_element_by_xpath("//span[@class='green']").text
        stats = str(stat)
        statn = int(stats)
        if statn > 40:


            quota = driver.find_element_by_class_name("widget__content.card__content")
            quot0 = driver.find_element_by_css_selector("div.widget__content.card__content > div:nth-child(1)")
            quota1a = quot0.find_element_by_css_selector(
                "div:nth-child(1) > div:nth-child(1) > div > div:nth-child(1) > span > span").text
            quota1a0 = quota1a.replace("(", " ")
            quota1 = quota1a0.replace(")", " ")
            fr1 = (1 / float(quota1) * 100)

            quotaxa = quot0.find_element_by_css_selector(
                "div:nth-child(1) > div:nth-child(2) > div > div:nth-child(1) > span > span").text
            quotaxa0 = quotaxa.replace("(", " ")
            quotax = quotaxa0.replace(")", " ")
            frx = (1 / float(quotax) * 100)

            quota2a = quot0.find_element_by_css_selector(
                "div:nth-child(1) > div:nth-child(3) > div > div:nth-child(1) > span > span").text
            quota2a0 = quota2a.replace("(", " ")
            quota2 = quota2a0.replace(")", " ")
            fr2 = (1 / float(quota2) * 100)

            quota1x = quot0.find_element_by_css_selector(
                "div:nth-child(1) > div:nth-child(4) > div > div:nth-child(1) > span > span")

            quotax2 = quot0.find_element_by_css_selector(
                "div:nth-child(1) > div:nth-child(5) > div > div:nth-child(1) > span > span")

            quota12 = quot0.find_element_by_css_selector(
                "div:nth-child(1) > div:nth-child(6) > div > div:nth-child(1) > span > span")

            if segr == "2":
                q_mer = quota2
                freq = fr2
            if segr == "1":
                q_mer = quota1
                freq = fr1
            matchr = 11

            ntab = driver.find_element_by_class_name("next_results_table")

            ntab1 = ntab.find_elements_by_css_selector("td.widget-results__score.text-center.limitstats")
            winris1 = 0
            winris2 = 0

            for scr in ntab1:
                ris = scr.find_element_by_css_selector("b").text
                ris0 = ris.split("-")
                ris1 = ris0[0]
                ris2 = ris0[1]
                if int(ris1) > int(ris2):
                    winris1 = winris1 + 1
                if int(ris1) < int(ris2):
                    winris2 = winris2 + 1

            if segr == "2":
                q_win = winris2
            if segr == "1":
                q_win = winris1

            vert_p = (q_win / matchr * 100)
            sfr = float(freq) - vert_p


            bm_qt_t = []
            boom_quot = driver.find_elements_by_css_selector("div.wrapper.bookmaker")
            bm_qt_f0 = driver.find_elements_by_xpath(
                "/html/body/div[2]/div[4]/div/div/div[2]/app-root/div/app-matches-detail/div/app-odds-box/app-list-item-simple/div/div/p[1]/span[1]")

            if len(boom_quot) != 0:
                if len(bm_qt_f0) != 0:
                    bm_qt_f = driver.find_element_by_xpath(
                        "/html/body/div[2]/div[4]/div/div/div[2]/app-root/div/app-matches-detail/div/app-odds-box/app-list-item-simple/div/div/p[1]/span[1]")
                    driver.execute_script("arguments[0].click();", bm_qt_f)
                    boom_quot0 = driver.find_elements_by_css_selector("div.wrapper.bookmaker")


                    for bq in boom_quot0:
                        bm_qt = []
                        bmk = bq.find_element_by_css_selector("div.bookmaker-name")
                        bmk1 = bq.find_element_by_css_selector("div.odds > div:nth-child(1)")
                        bmkx = bq.find_element_by_css_selector("div.odds > div:nth-child(2)")
                        bmk2 = bq.find_element_by_css_selector("div.odds > div:nth-child(3)")
                        bm_qt.append(bmk.text)
                        bm_qt.append(bmk1.text)
                        bm_qt.append(bmkx.text)
                        bm_qt.append(bmk2.text)
                        bm_qt_t.append(bm_qt)

                    if segr == "2":
                        bm_qt_ts = sorted(bm_qt_t, key=lambda x: x[3], reverse=True)
                        bmkr = bm_qt_ts[0][0]
                        bmkq = bm_qt_ts[0][3]
                    elif segr == "1":
                        bm_qt_ts = sorted(bm_qt_t, key=lambda x: x[1], reverse=True)
                        bmkr = bm_qt_ts[0][0]
                        bmkq = bm_qt_ts[0][1]


                else:
                    boom_quot0 = driver.find_elements_by_css_selector("div.wrapper.bookmaker")


                    for bq in boom_quot0:
                        bm_qt = []
                        bmk = bq.find_element_by_css_selector("div.bookmaker-name")
                        bmk1 = bq.find_element_by_css_selector("div.odds > div:nth-child(1)")
                        bmkx = bq.find_element_by_css_selector("div.odds > div:nth-child(2)")
                        bmk2 = bq.find_element_by_css_selector("div.odds > div:nth-child(3)")
                        bm_qt.append(bmk.text)
                        bm_qt.append(bmk1.text)
                        bm_qt.append(bmkx.text)
                        bm_qt.append(bmk2.text)
                        bm_qt_t.append(bm_qt)

                    if segr == "2":
                        bm_qt_ts = sorted(bm_qt_t, key=lambda x: x[3], reverse=True)
                        bmkr = bm_qt_ts[0][0]
                        bmkq = bm_qt_ts[0][3]
                    elif segr == "1":
                        bm_qt_ts = sorted(bm_qt_t, key=lambda x: x[1], reverse=True)
                        bmkr = bm_qt_ts[0][0]
                        bmkq = bm_qt_ts[0][1]





            else:

                continue
        else:

            continue

    else:

        continue

    if float(q_mer) < float(bmkq):
        bmkqr = bmkq
    else:
        continue

    bktest.append(lk)
    bktest.append(campnaz.text)
    bktest.append(squadre.text)
    bktest.append(q_mer)
    bktest.append(stat)
    bktest.append(sfr)
    bktest.append(segr)
    bktest.append(bmkr)
    bktest.append(bmkqr)


    bktest_tot.append(bktest)

driver.close()
driver.quit()

writer = pd.ExcelWriter('bktest_sb_fg.xlsx', engine='openpyxl', mode="a")

testbk = pd.DataFrame(bktest_tot)

testbk.to_excel(writer, sheet_name="data", index=False, header=False)
writer.save()
